#include <bits/stdc++.h>

using namespace std;

const int kMaxN = 100005;

set<int> G[kMaxN], Bad[kMaxN];
int sumK;
int main() {
	freopen("incurcatura.in", "r", stdin);
	freopen("incurcatura.out", "w", stdout);
	int n;
	int p;
	cin >> p;
	assert(1 <= p && p <= 2);
	cin >> n;
	assert(1 <= n && n <= 1e5);

	for (int node = 1; node <= n; ++node) {
		int k;
		cin >> k;
		sumK += k;
		while (k--) {
			int x;
			cin >> x;
			G[node].insert(x);
		}
	}

	assert(1 <= sumK && sumK <= 4 * 100000);

	int bad_edges = 0;

	for (int i = 1; i <= n; ++i) {
		for (auto j : G[i]) {
			if (G[j].count(i) == 0) {
				Bad[i].insert(j);
				Bad[j].insert(i);
				++bad_edges;
			}
		}
	}

	int sol = -1;

	// One is wrong
	for (int node = 1; node <= n; ++node) {
		if (Bad[node].size() == bad_edges) {
			if (sol != -1) {
				cerr << "ANOTHER SOL: " << node << endl;
				assert(false);
			}
			cout << node << endl;
			sol = 1;
		}
	}

	if (sol != -1) return 0;

	auto cmp = [](int a, int b) {
		return make_pair(Bad[a].size(), a) > make_pair(Bad[b].size(), b);
	};
	set<int, decltype(cmp)> OrderSet(cmp);

	for (int i = 1; i <= n; ++i) {
		OrderSet.insert(i);
	}

	assert(bad_edges > 0);

	// Two are wrong
	for (int node = 1; node <= n; ++node) {
		OrderSet.erase(node);
		for (auto vec : Bad[node]) {
			OrderSet.erase(vec);
			Bad[vec].erase(node);
			OrderSet.insert(vec);
		}

		int oth = *OrderSet.begin();

		if (oth > node && Bad[oth].size() + Bad[node].size() == bad_edges) {
			if (sol != -1) {
				cerr << "ANOTHER SOL: " << node << " " << oth << endl;
				assert(false);
			}
			cout << node << " " << oth << endl;
			sol = 2;
		}

		for (auto vec : Bad[node]) {
			OrderSet.erase(vec);
			Bad[vec].insert(node);
			OrderSet.insert(vec);
		}

		OrderSet.insert(node);
	}

	assert(sol == 2);


	return 0;
}
