#include <bits/stdc++.h>

using namespace std;

const int kMaxN = 500005;
int V[kMaxN];
int n, lo, hi;

pair<int, int> DP[kMaxN];

pair<int, int> unite(pair<int, int> a, pair<int, int> b) {
	if(a.first == -1) return b;
	if(b.first == -1) return a;
	return { min(a.first, b.first), max(a.second, b.second) };
}

pair<int, int> intersect(pair<int, int> a, pair<int, int> b) {
	if(a.first == -1) return a;
	if(b.first == -1) return b;

	auto ret = make_pair(max(a.first, b.first), min(a.second, b.second));
	if(ret.first > ret.second) return {-1, -1};
	return ret;
}

int ForwardProp() {
	DP[0] = {0, 0};


	for(int i = 1; i <= n; ++i) {
		int last = -1;
		DP[i] = {-1, -1};

		for(int k = 0; k <= hi; ++k) {
			if(i - k < 0) break;


			if(k >= lo && DP[i - k].first != -1) {
				if(last == -1) {
					DP[i] = unite(DP[i], make_pair(DP[i - k].first + 1, DP[i - k].second + 1));
				} else {
					if(DP[i - k].first + 1 <= last && last <= DP[i - k].second + 1)
						DP[i] = unite(DP[i], make_pair(last, last));
				}
			}

			if(V[i - k] != -1) {
				if(last == -1) last = V[i - k];
				if(last != V[i - k]) break;
			}
		}
	}
	return DP[n].second;
}

void BackProp(int maxx) {
	DP[n + 1] = {maxx + 1, maxx + 1};

	for(int i = n; i >= 1; --i) {
		int last = -1;
		DP[i] = {-1, -1};

		for(int k = 0; k <= hi; ++k) {
			if(i + k > n + 1) break;

			if(k >= lo && DP[i + k].first != -1) {
				if(last == -1) {
					DP[i] = unite(DP[i], make_pair(DP[i + k].first - 1, DP[i + k].second - 1));
				} else {
					if(DP[i + k].first - 1 <= last && last <= DP[i + k].second - 1)
						DP[i] = unite(DP[i], make_pair(last, last));
				}
			}

			if(V[i + k] != -1) {
				if(last == -1) last = V[i + k];
				if(last != V[i + k]) break;
			}
		}
	
	}
}

int main() {
	freopen("startrek.in","r",stdin);
	freopen("startrek.out","w",stdout);	
int m;
	cin >> n >> lo >> hi >> m;

	memset(V, -1, sizeof(V));

	while(m--) {
		int pos, val;
		cin >> pos >> val;
		V[pos] = val;
	}

	int maxx = ForwardProp();
	BackProp(maxx);
	

	cout << maxx << endl;
	int pos = 1;
	for(int val = 1; val <= maxx; ++val) {
		int go = -1;
		for(int nxt = pos + lo; nxt <= pos + hi; ++nxt) {
			if(nxt > n + 1) break;

			if(DP[nxt].first != -1 && DP[nxt].first <= val + 1) go = nxt;

			if(V[nxt] != -1 && V[nxt] != val)
				break;
		}
		assert(go != -1);
		while(pos != go) {
			cout << val << " ";
			++pos;
		}
	}
	assert(pos == n + 1);
	cout << endl;


	return 0;
}
