/// Solutie TRIS 94 puncte
/// Autor: Lucian Bicsi

#include <bits/stdc++.h>

using namespace std;

// [1, 2, 3, 3*]
vector<vector<int>> caps = {
	{1, 0, 1, 0},
	{0, 2, 0, 0},
	// {2, 1, 0, 0},
	// {0, 0, 0, 2},
	// {1, 1, 0, 1},
	// {1, 1, 1, 0},
	// {0, 3, 0, 0}
};

const int kSize = 800;

struct Solver {

	vector<int> split;
	vector<vector<int>> ret;

	Solver() : split(4, 0), ret(kSize, vector<int>(kSize, 0)) {}

	void BuildSolution(vector<int> pieces, int c1, int c2) {
		int up = 3, dw = 0;
		int col = 0;

		int piece = 1;
		auto alloc = [&]() {
			return piece++;
		};

		auto putCap = [&](int cid) {
			int p1 = alloc(), p2 = alloc();
			if(cid == 1) {
				ret[dw][col] = ret[dw + 1][col] = p1;
				ret[dw + 2][col] = ret[dw + 3][col] = p2;
			} else {
				ret[dw][col] = p1;
				ret[dw + 1][col] = ret[dw + 2][col] = ret[dw + 3][col] = p2;
			}
			++col;
		};
		auto putPiece = [&](int pid) {
			#define small_macro() ret[dw][col] = p1, ret[up][col] = p2, ++col
			
			int p1 = alloc(), p2 = alloc();
			pieces[pid] -= 2;
			
			small_macro();
			if(split[pid]) split[pid] = 0, p1 = alloc();
			if(pid == 0) return;
			small_macro();
			if(pid == 1) return;
			if(pid == 3) ++up, ++dw, --col;
			small_macro();	

			#undef small_macro
		};

		putCap(c1);
		for(int i = 3; i >= 0; --i)
			while(pieces[i])
				putPiece(i);
		putCap(c2);
	}

	bool TrySolve(vector<int> pieces, int c1, int c2) {
		for(int i = 0; i < 4; ++i) {
			pieces[i] -= caps[c1][i] + caps[c2][i];
			if(pieces[i] < 0) 
				return false;
		}

		if(pieces[3] % 2) ++pieces[3], --pieces[1], --pieces[0], ++split[3];
		if(pieces[2] % 2) ++pieces[2], --pieces[1], --pieces[0], ++split[2];
		if(pieces[1] % 2) ++pieces[1], --pieces[0], --pieces[0], ++split[1];
		
		if(pieces[0] % 2 || pieces[0] == 0 && pieces[1] == 0 && pieces[2] == 0) 
			return false;
		for(int i = 0; i < 4; ++i) {
			if(pieces[i] < 0)
				return false;
		}

		// Found solution
		BuildSolution(pieces, c1, c2);
		return true;
	}

	static vector<vector<int>> Solve(vector<int> pieces) {
		int cs = caps.size();
		for(int i = 0; i < cs; ++i)
			for(int j = i; j < cs; ++j) {
				Solver solver;
				if(solver.TrySolve(pieces, i, j))
					return solver.ret;
			}
		return {};
	}
};

void Output(ostream &out, vector<vector<int>> mat) {
	assert(!mat.empty());
	out << mat.size() << " " << mat[0].size() << endl;
	for(auto row : mat) {
		for(auto cell : row)
			out << cell << " ";
		out << endl;
	}
}

int main() {
	ifstream fin("tris.in");
	ofstream fout("tris.out");

	vector<int> freq(4);
	for(auto &x : freq)
		fin >> x;

	Output(fout, Solver::Solve(freq));

	return 0;
}