#include <cstdio>
#include <vector>
#include <cmath>

using namespace std;

const int MAX_VAL = 3;
int buf[2 * MAX_VAL + 1];
int *countAvail = buf + MAX_VAL;

long long sol = 0;

void solve(const vector<int> types) {
    int buf[2 * MAX_VAL + 1] = {0};
    int *countUsages = buf + MAX_VAL;
    int lastHeight = 0, area = 0;
    for (int i = 0; i < (int)types.size(); i++) {
        int nextHeight = lastHeight + types[i];
        area += abs(types[i]) * (lastHeight + nextHeight); //divide in half later
        lastHeight = nextHeight;
        countUsages[types[i]]++;
    }
    area /= 2;
    int numMoves = 1 << 30;
    for (int i = -MAX_VAL; i <= MAX_VAL; i++) {
        if (countUsages[i]) {
            numMoves = min(numMoves, countAvail[i] / countUsages[i]);
        }
    }
    for (int i = -MAX_VAL; i <= MAX_VAL; i++) {
        countAvail[i] -= countUsages[i] * numMoves;
    }
    sol += (long long)numMoves * area;
}

int main() {
    freopen("minarea.in", "r", stdin);
    freopen("minarea.out", "w", stdout);
    for (int i = 1; i <= MAX_VAL; i++) {
        scanf("%d", countAvail + i);
    }
    for (int i = 1; i <= MAX_VAL; i++) {
        scanf("%d", countAvail - i);
    }

    solve({+3, -3});
    
    if (!countAvail[MAX_VAL]) {
        for (int i = 1; i <= MAX_VAL; i++) {
            swap(countAvail[i], countAvail[-i]);
        }
    }
    solve({+3, -2, -1});
    solve({+3, -1, -1, -1});
    solve({+3, -2, +1, -2});
    solve({+3, -2, +3, -2, -2});
    solve({+2, -2});
    solve({+2, -1, -1});
    solve({+1, +1, -2});

    solve({+1, -1});
    
    printf("%lld\n", sol);
    
    return 0;
}

